package de.ozgcloud.user.settings;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.NullValueCheckStrategy;
import org.mapstruct.ReportingPolicy;

import de.ozgcloud.user.userprofile.GrpcUserSettings;

@Mapper(unmappedTargetPolicy = ReportingPolicy.WARN, nullValueCheckStrategy = NullValueCheckStrategy.ALWAYS)
public interface UserSettingsMapper {

	@Mapping(target = "mergeFrom", ignore = true)
	@Mapping(target = "clearField", ignore = true)
	@Mapping(target = "clearOneof", ignore = true)
	@Mapping(target = "mergeUnknownFields", ignore = true)
	@Mapping(target = "unknownFields", ignore = true)
	@Mapping(target = "allFields", ignore = true)
	@Mapping(target = "notificationsSendForAll", source = "notificationsSendFor")
	GrpcUserSettings toGrpc(UserSettings userSettings);

	default boolean map(NotificationsSendFor sendFor) {
		return NotificationsSendFor.ALL.equals(sendFor);
	}
}
