package de.ozgcloud.user;

import static org.assertj.core.api.Assertions.*;

import java.util.List;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;

class UserRoleTest {

	@Nested
	class TestContainsWithinRoleHierarchy {

		@Test
		void shouldReturnTrue() {
			var containsRole = UserRole.containsWithinRoleHierarchy(List.of(UserRole.VERWALTUNG_LOESCHEN), UserRole.VERWALTUNG_USER);

			assertThat(containsRole).isTrue();
		}

		@Test
		void shouldReturnFalse() {
			var containsRole = UserRole.containsWithinRoleHierarchy(List.of(UserRole.VERWALTUNG_USER), UserRole.VERWALTUNG_LOESCHEN);

			assertThat(containsRole).isFalse();
		}

		@Test
		void shouldReturnTrueOnSame() {
			var containsRole = UserRole.containsWithinRoleHierarchy(List.of(UserRole.VERWALTUNG_USER), UserRole.VERWALTUNG_USER);

			assertThat(containsRole).isTrue();
		}

	}

}