package de.ozgcloud.user.settings;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;

class UserSettingsTest {

	@Nested
	class TestConstructor {
		@Test
		void shouldCreateWithVorgangCreatedSet() {
			var userSettings = new UserSettings(NotificationsSendFor.ALL);

			assertThat(userSettings.isVorgangCreated()).isTrue();
		}

		@Test
		void shouldCreateWithVorgangCreatedUnset() {
			var userSettings = new UserSettings(NotificationsSendFor.NONE);

			assertThat(userSettings.isVorgangCreated()).isFalse();
		}

		@Test
		void shouldCreateWithDefaultValues() {
			var userSettings = new UserSettings();

			assertThat(userSettings).usingRecursiveComparison().isEqualTo(UserSettings.createDefault());
		}
	}

	@Nested
	class TestCreateDefault {

		@Test
		void shouldHaveDefaultSettings() {
			assertThat(UserSettings.createDefault()).usingRecursiveComparison().isEqualTo(
					UserSettings.builder().notificationsSendFor(NotificationsSendFor.NONE).vorgangCreated(false).vorgangAssignedToUser(true)
							.postfachNachrichtFromAntragsteller(true).wiedervorlageDueToday(true).build());
		}

	}
}